<?


class PGNParser{
	
	
	var $pgnFile;
	var $pgnFileContent;
	var $gameData;
	function setPgnFile($inputFile)
	{
		$this->pgnFile = $inputFile;		
		
	}	
	
	
	function readPgnFile()
	{
		if(!file_exists($this->pgnFile)){
			$this->pgnFileContent = "Unable to read content of pgn file";
			return;
		}
		$fh = fopen($this->pgnFile,"r");
		$this->pgnFileContent = fread($fh,filesize($this->pgnFile));	
		fclose($fh);		
		
		$this->pgnFileContent = str_replace("[","<",$this->pgnFileContent);
		$this->pgnFileContent = str_replace(">",">",$this->pgnFileContent);
				
	}
	
	
	function createChessData($gameIndex=false)
	{
		$this->gameData = array();		

		
		
		$tokens = explode("<Event",$this->pgnFileContent);
		
		$min = 0;
		$max = count($tokens);
		if($gameIndex){
			$min = $gameIndex;
			$max = $gameIndex+1;
		}
		
		for($no=$min;$no<$max;$no++){
			$this->gameData[$no] = array();
			$this->gameData[$no]['event'] = preg_replace("/.*?\"([^\"]*?)\".*/s","\\1",$tokens[$no]);
			$this->gameData[$no]['white'] = preg_replace("/.*?<White.*?\"([^\"]*)\".*/si","\\1",$tokens[$no]);
			$this->gameData[$no]['black'] = preg_replace("/.*?<Black.*?\"([^\"]*?)\".*/si","\\1",$tokens[$no]);
			$this->gameData[$no]['result'] = preg_replace("/.*?<Result.*?\"([^\"]*?)\".*/si","\\1",$tokens[$no]);
			$this->gameData[$no]['date'] = preg_replace("/.*?<Date.*?\"([^\"]*?)\".*/si","\\1",$tokens[$no]);
			$this->gameData[$no]['round'] = preg_replace("/.*?<Round.*?\"([^\"]*?)\".*/si","\\1",$tokens[$no]);
			$this->gameData[$no]['eco'] = preg_replace("/.*?<ECO.*?\"([^\"]*?)\".*/si","\\1",$tokens[$no]);
			
			$this->gameData[$no]['white'] = str_replace("'","&#039;",$this->gameData[$no]['white']);
			$this->gameData[$no]['black'] = str_replace("'","&#039;",$this->gameData[$no]['black']);
			$this->gameData[$no]['result'] = str_replace("'","&#039;",$this->gameData[$no]['result']);

			$gamePos = strpos($tokens[$no],"\n1.");
			$this->gameData[$no]['gameData'] = trim(substr($tokens[$no],$gamePos));
		}
	}
	
	
	function outputMoves($gameIndex)
	{
		$moves = preg_split("/\d{1,3}\./",$this->gameData[$gameIndex]['gameData']);
		
		echo "widgetObj.moves = new Array();\n";
		
		for($no=1;$no<count($moves);$no++){
			$moves[$no] = trim($moves[$no]);
			$playerMoves = explode(" ",$moves[$no]);
			echo "widgetObj.moves[".($no-1)."] = ['".$playerMoves[0]."','".$playerMoves[1]."'];\n";			
			
		}		
	}
	
	function outputHeader($gameIndex)
	{
		echo "document.getElementById('headerText').innerHTML = '".$this->gameData[$gameIndex]['white']." vs ".$this->gameData[$gameIndex]['black']." (".$this->gameData[$gameIndex]['date'].")';\n";
	}
	
	
	
	function outputGames()
	{
		for($no=1;$no<count($this->gameData);$no++){
			echo "widgetObj.games[".($no-1)."] = ['".$this->gameData[$no]['white']."','".$this->gameData[$no]['black']."','".$this->gameData[$no]['result']."'];\n";
		}		
	}	
}


?>

